"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.signRequestBYBIT = void 0;
const node_crypto_1 = require("node:crypto");
function signRequestBYBIT(config, data) {
    const now = Date.now();
    const recvWindow = data.recvWindow ?? 60000;
    config.headers ??= {};
    config.headers['X-BAPI-TIMESTAMP'] = now.toString();
    config.headers['X-BAPI-RECV-WINDOW'] = recvWindow;
    config.headers['X-BAPI-API-KEY'] = data.key;
    config.headers['X-BAPI-SIGN-TYPE'] = '2';
    config.headers['X-BAPI-SIGN'] = (0, node_crypto_1.createHmac)('sha256', data.secret)
        .update(`${now}${data.key}${recvWindow}${config.data
        ? JSON.stringify(config.data)
        : config.params && Object.keys(config.params).length
            ? new URLSearchParams(config.params).toString()
            : ''}`)
        .digest('hex');
    return config;
}
exports.signRequestBYBIT = signRequestBYBIT;
