"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.signRequestCRYPTOCOM = void 0;
const node_crypto_1 = require("node:crypto");
function signRequestCRYPTOCOM(config, data) {
    const now = Date.now();
    const nonce = now - 1000;
    const sha256String = (0, node_crypto_1.createHmac)('sha256', data.secret)
        .update(`${config.url}${now}${data.key}${config.data
        ? JSON.stringify(config.data)
        : config.params && Object.keys(config.params).length
            ? `${Object.keys(config.params)
                .sort()
                .reduce((a, b) => a + b + config.params[b], '')}`
            : ''}${nonce}`)
        .digest('hex');
    config['data'] = {
        id: now,
        method: config.url,
        params: config.params,
        api_key: data.key,
        sig: sha256String,
        nonce,
    };
    return config;
}
exports.signRequestCRYPTOCOM = signRequestCRYPTOCOM;
